/* cssbj62.c */
/* Finite Difference Method for the Fisher Equation ۲ˡ*/
/* ե뤫ǡɤ߹ */
#include "csc.h"     /* ͷ׻饤֥Υإåե */
#include "eagle.h" /* եå饤֥Υإåե */
#include <string.h>
#define Mmax (401)
unsigned long black, blue;  /* ̾ */

/* ʬۤꤹؿ */
void initial_distribution(M, u)
  int M; double u[];
{
  int i; double amp;
  printf("amp = (std:0.05) ? "); scanf("%lf", &amp);
  for (i = 0; i <= M; i++) u[i] = 0.0;
  for (i = 0; i < 10; i++) u[i] = fabs(amp);
}

/* u(t.x) Υդؿ */
void display(M, L, u)
  int M; double L; double u[];
{  
  w_clear();
  m_box(0.0, -0.1, L, 1.0, 0); m_line(0.0, 0.0, L, 0.0);
  set_foreground(blue); set_line_width(3); 
  m_graph(M, 0.0, L, u);
  set_foreground(black); set_line_width(1);
}

main(int argc, char *argv[])
{
  Window      w0;
  double      u[Mmax], u_new[Mmax];
  double      L, diff, lambda, dx, dt, time;
  int         wx, wy, M, i, j, k, kk, ndisp, disp_step, shift;
  FILE        *fp; /* եݥ󥿡 */
  extern void initial_distribution(), display();
  int         Fflag = 0;
  double      a;

  /* ե뤫ɤ߹४ץ */
  if (argc == 2) {
      if (strcmp(argv[1],"-f") == 0) {
          Fflag = 1;
      } else {
          printf("ץλְ꤬äƤޤ\n");
          exit (1);
      }
  } else if (argc > 2) {
      printf("ץλְ꤬äƤޤ\n");
      exit(1);
  }

  /* ǡɤ߹ */
  if (Fflag == 0) {
      printf("Diffusion coefficient diff = (std: 1.0) ? "); /* Ȼ */
      scanf("%lf", &diff);
      printf("Size of interval L = (std: 200.0) ? "); /* ׻֤Ĺ */
      scanf("%lf", &L);
      printf("Degree of freedom M < %d, M = (std: 200) ? ", Mmax); 
      /* ͳ M  */
      scanf("%d", &M); dx = L/M;
      dt = 0.5; if (dx*dx/diff/2.0 < dt) dt = dx*dx/diff/2.0; 
      printf("dt = (0.0 < dt < %lf) ? ", dt); /* dt  */
      scanf("%lf", &dt); lambda = diff*dt/dx/dx;
      printf("disp_step = (std: 2) ? "); /* սϴֳ֤ */
      scanf("%d", &disp_step);
      /* ʬۤλ */
      initial_distribution(M, u); time = 0.0;
      printf("a = (0.0 < a < 1.0) ? "); scanf("%lf", &a);
  } else if (Fflag == 1) {
      fp = fopen("result.data", "r");  /* ե򳫤 */
      fscanf(fp, "%lf %lf %lf %d %d %lf", &diff, &L, &dt, &M, &disp_step, &a);
      for (i = 0; i <= M; i++) fscanf(fp, "%lf", &u[i]); 
      fclose(fp);                      /* եĤ */
      dx = L/M; lambda = diff*dt/dx/dx;
  }

  time = 0.0;

  wx = 600; wy = 400;                /* ɥ礭λ */
  w0 = x_init(wx, wy, "Eagle_data"); /* ǽΥɥ w0 򳫤 */
  black = set_color(0, 0, 0);        /*  */
  blue = set_color(0, 0, 255);       /*  */

  /* ɸϤλ */
  m_trans_def(0.0, -0.1, L, 1.0, 20, 30, wx-40, wy-40);

  display(M, L, u); /* u(t.x) Υդ */

  while (1) {
    printf("Input  0 for ndisp to exit\n");
    printf("Input -1 for file output\n");
    printf("Input -2 for Shift\n");
    printf("Number of displays ndisp = "); scanf("%d", &ndisp);

    /* ndisp = 0 ʤ׻ */
    if (ndisp == 0) break;

    /* ndisp = -1 ʤեؤν */
    if (ndisp == -1) {
      fp = fopen("result.data", "w");  /* ե򳫤 */
      fprintf(fp, "%lf %lf %lf %d %d %lf\n", diff, L, dt, M, disp_step, a);

      for (i = 0; i <= M; i++) fprintf(fp, "%lf\n", u[i]); 
      fclose(fp);                      /* եĤ */
    }


    /* ndisp == -2 ʤ shift  */
    if (ndisp == -2) {
        printf("shift = "); scanf("%d", &shift);
        if (shift > 0) {
            for (i = M; i >= shift; i--) u[i] = u[i-shift];
            for (i = shift-1; i >= 0; i--) u[i] = u[shift];
        }
        if (shift < 0) {
            for (i = 0; i <= M+shift; i++) u[i] = u[i-shift];
            for (i = M+shift+1; i <= M; i++) u[i] = u[M+shift];
        }
        display(M, L, u); /* u(t.x) Υդ */
    }

    /* ndisp ǻꤵ줿ΥսϤ򤹤뤿η׻򤹤 */
    for (k = 0; k < ndisp; k++) {
      for (kk = 0; kk < disp_step; kk++) {
        if (u[i] <= a) {
          u_new[0] = (1-2*lambda)*u[0] + 2*lambda*u[1];
          u_new[0] = u_new[0]/(1-dt*u[0] + a*dt + dt*u[0]*u[0] - a*dt*u[0]);
          for (i = 1; i < M; i++) {
              u_new[i] = (1-2*lambda)*u[i] + lambda*(u[i+1]+u[i-1]);
              u_new[i] = u_new[i]/(1-dt*u[i] + a*dt + dt*u[i]*u[i] - a*dt*u[i]);
          }
          u_new[M] = (1 - 2*lambda)*u[M] + 2*lambda*u[M-1];
          u_new[M] = u_new[M] / (1-dt*u[M] + a*dt + dt*u[M]*u[M] - a*dt*u[M]);
        } else {
          u_new[0] = (-2*lambda + dt*u[0] - a*dt + 1)*u[0] + 2*lambda*u[1];
          u_new[0] = u_new[0] / (1 + dt*u[0]*u[0] - a*dt*u[0]);
          for (i = 1; i < M; i++) {
            u_new[i] = (-2*lambda+dt*u[i]-a*dt+1)*u[i] + lambda*(u[i+1]+u[i-1]);
            u_new[i] = u_new[i] / (1 + dt*u[i]*u[i] - a*dt*u[i]);
          }
          u_new[M] = (-2*lambda + dt*u[M]-a*dt+1)*u[M] + 2*lambda*u[M-1];
          u_new[M] = u_new[M] / (1 + dt*u[M]*u[M] - a*dt*u[M]);
        }
        for (i = 0; i <= M; i++) u[i] = u_new[i];
        time = time + dt;

      }
      display(M, L, u);
    }
  }

  printf("Type 0 to exit "); scanf("%d", &j); /* λԤ */
  w_close(w0); /* ɥξõ */
  x_term();    /* եåνλ */
}

